<template>
    <div>
        <v-container>
            <v-card width="100%" class="mb-2">
                <v-card-text>
                    <h3 class="center">Filtre service</h3>
                    <v-row>
                        <v-col xs="3" md="3">
                            <v-text-field v-model="searchWord" label="Rechercher"></v-text-field>
                        </v-col>
                        <v-col sm="3">
                            <v-autocomplete
                                v-model="searchCat"
                                :items="categorieService"
                                item-text="nom"
                                dense
                                filled
                                label="Categorie"
                            ></v-autocomplete>
                        </v-col>
                        <v-col sm="3">
                            <v-autocomplete
                                v-model="searchCommune"
                                :items="items"
                                dense
                                filled
                                label="Commune"
                            ></v-autocomplete>
                        </v-col>

                        
                        <v-col xs="3" md="3" align="center" align-self="center">
    
                            <v-btn color="error" @click="resetAll">
    
                                Annuler
    
                            </v-btn>
    
                        </v-col>
                    </v-row>
                </v-card-text>
            </v-card>
            <v-row>
                <v-col xs="4" sm="4" v-for="service in pagination.data" :key="service.id">
                    <v-card
                        min-height="100"
                    >
                        <v-card-text>
                            <v-row>
                                <v-col xs="2" sm="4">
                                    <v-img width="100" :lazy-src="$config.DEFAULT_URL +'service/'+ service.images[0]" :src="$config.DEFAULT_URL +'service/'+ service.images[0]" ></v-img>
                                </v-col>
                                <v-col xs="10" sm="8">
                                    <h3>{{ service.nom }}</h3>
                                      {{ service.description.substring(0,20)}}... <a href="/articles/1">lire la suite</a>
                                </v-col>
                            </v-row>
                            <v-row>
                                <v-col xs="2" sm="4" offset-sm="8">
                                   <span style="color:red"> {{ (service.distance)? service.distance+" Km": ""}}</span>
                                </v-col>    
                            </v-row>  
                        </v-card-text>
                    </v-card>
                </v-col>
                <v-col sm="12">
                    <div class="text-center">
                        <v-pagination
                        v-model="page"
                        :length="pagination.total_pages"
                        ></v-pagination>
                    </div> 
                </v-col>
            </v-row>
        </v-container>
    </div>
</template>
<script>



export default {
    name: "services",
    data: () => ({
      pagination:{},  
      searchWord:"",
      searchCommune:"",
      searchCat:"",
      page:1,
      items: ['Cocody', 'Abobo', 'Faya', 'Attoban'],
      categorieService:[],
      longitude:null,
      latitude:null,
    }),

    created(){
      this.getPosition();
      this.getCategorie();
      this.getService(this.page);

    },

    methods:{

        getPosition(){


           if(navigator.geolocation){
                  navigator.geolocation.getCurrentPosition((position)=>{ 
                       this.longitude = position.coords.longitude;
                       this.latitude = position.coords.latitude;
                  })

                 }
           
        },

        async getCategorie() {

            try {
                await this.$store.dispatch('autoshop/loadCategorie');
                this.categorieService = this.$store.getters["autoshop/categories"] ;
            } catch (e) {
                console.log(e);
            }
        },

        
        async getService(page) {
            try {
                await this.$store.dispatch('autoshop/loadService');
                var allService = this.$store.getters["autoshop/services"];

                 var allServiceByLocation = [];
               
             

                 allService.forEach(service => {
                     
                      if(service.longitude && service.latitude){


                       console.log("latitude",this.latitude);
                       console.log("longitude",this.longitude);
                        
                        
                         var dist = this.distance(this.latitude,this.longitude,service.latitude,service.longitude,"K");

                         let disString = dist.toString();
                         let arrayDist = disString.split('.');
                          
                          allServiceByLocation.push(
                              {
                                id:service._id,
                                nom:service.nom,
                                images:service.images,
                                description:service.description,
                                longitude:service.longitude,
                                latitude:service.latitude,
                                isSpecial:service.isSpecial,
                                distance:arrayDist[0],
                                client:service.client,
                                contactun:service.contactun,
                                type_service:service.type_service,
                                zone:service.zone,
                                contactdeux:service.contactdeux  
                              }
                              )

                         
                         
                      }else{
                             allServiceByLocation.push(
                              {
                                id:service._id,
                                nom:service.nom,
                                images:service.images,
                                description:service.description,
                                longitude:service.longitude,
                                latitude:service.latitude,
                                isSpecial:service.isSpecial,
                                distance:"",
                                client:service.client,
                                contactun:service.contactun,
                                type_service:service.type_service,
                                zone:service.zone,
                                contactdeux:service.contactdeux  
                              }
                              )
                      }

                 });


                 

                  this.pagination = this.$config.paginator(allServiceByLocation,page);

                 


            } catch (e) {
                console.log(e);
            }
        },

        distance(lat1, lon1, lat2, lon2, unit) {
	if ((lat1 == lat2) && (lon1 == lon2)) {
		return 0;
	}
	else {
		var radlat1 = Math.PI * lat1/180;
		var radlat2 = Math.PI * lat2/180;
		var theta = lon1-lon2;
		var radtheta = Math.PI * theta/180;
		var dist = Math.sin(radlat1) * Math.sin(radlat2) + Math.cos(radlat1) * Math.cos(radlat2) * Math.cos(radtheta);
		if (dist > 1) {
			dist = 1;
		}
		dist = Math.acos(dist);
		dist = dist * 180/Math.PI;
		dist = dist * 60 * 1.1515;
		if (unit=="K") { dist = dist * 1.609344 }
		if (unit=="N") { dist = dist * 0.8684 }
		return dist;
	}
},
        resetAll(){

            this.searchWord="";
            this.searchCommune="";
            this.searchCat = "";

        },

        rechercheFiltre(){
            
             var allService = this.$store.getters["autoshop/services"];

                 var allServiceByLocation = [];
               
                 if(navigator.geolocation){
                  navigator.geolocation.getCurrentPosition((position)=>{ 
                       this.longitude = position.coords.longitude;
                       this.latitude = position.coords.latitude;
                  })

                 }

                 allService.forEach(service => {
                     
                      if(service.longitude && service.latitude){

                        
                        
                         var dist = this.distance(this.latitude,this.longitude,service.latitude,service.longitude,"K");

                         let disString = dist.toString();
                         let arrayDist = disString.split('.');
                          
                          allServiceByLocation.push(
                              {
                                id:service._id,
                                nom:service.nom,
                                images:service.images,
                                description:service.description,
                                longitude:service.longitude,
                                latitude:service.latitude,
                                isSpecial:service.isSpecial,
                                distance:arrayDist[0],
                                client:service.client,
                                contactun:service.contactun,
                                type_service:service.type_service,
                                zone:service.zone,
                                contactdeux:service.contactdeux  
                              }
                              )

                         
                         
                      }else{
                             allServiceByLocation.push(
                              {
                                id:service._id,
                                nom:service.nom,
                                images:service.images,
                                description:service.description,
                                longitude:service.longitude,
                                latitude:service.latitude,
                                isSpecial:service.isSpecial,
                                distance:"",
                                client:service.client,
                                contactun:service.contactun,
                                type_service:service.type_service,
                                zone:service.zone,
                                contactdeux:service.contactdeux  
                              }
                              )
                      }

                 });


          
            const result = allServiceByLocation.filter((serv) => {

               
                    return (serv.nom.toLowerCase().includes(this.searchWord.toLowerCase()) && serv.type_service.toLowerCase().includes(this.searchCat.toLowerCase()) && serv.zone.toLowerCase().includes(this.searchCommune.toLowerCase()))

            });

            console.log("resultat",result);

             this.pagination = this.$config.paginator(result);

        }
       

    },

    watch:{
        
        page(value){
             this.getService(value);
        },

        searchWord(){
            this.rechercheFiltre()
        },
        searchCat(){
          this.rechercheFiltre()
        },
        searchCommune(){
            this.rechercheFiltre()
        }

    }
}
</script>>